#! /bin/sh

DB=/home/gsql/database/sysadm

if [ ! -d $DB ] 
then
	mkdir $DB
fi

if [ ! -f $DB/files~ ]
then
	find / -printf "%p\t%f\t%l\t%TY.%Tm.%Td-%TT\t%s\t%g\t%u\n" \
		> $DB/tmp
	sort -k 1,1 < $DB/tmp > $DB/files~
	rm $DB/tmp

	cat <<'_here' > $DB/files@
path	62	char
file	30	char
link	62	char
time	19	char
size	10	int
group	8	char
user	8	char
packet	14	char
status	1	char
_here
fi

if [ -d /install/installed ]
then
	> $DB/tmp
	cat <<'_here' > $DB/sls_installed@
path	62	char
packet	14	char
_here

	for x in /install/installed/*
	do
		p=`basename $x`
		sed -e 's/^\.//' -e 's/^\///' <$x |
		awk "{ printf \"/%s\\t%s\\n\", \$1, \"$p\" }" >>$DB/tmp
	done
	sort -k 1,1 $DB/tmp > $DB/sls_installed~ 
	rm $DB/tmp

	join -a1 "-t	" $DB/files~ $DB/sls_installed~ > $DB/tmp
	mv $DB/tmp $DB/files~
fi

touch $DB/timestamp
	

