#ifdef __cplusplus
extern "C" {
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef __cplusplus
	}
#endif

#include "tw_types.h"
#include "mystring.h"
#include "ppg.h"

int ppg::token()
{	if (p_fatal) return(0);
	debug("token,");

	char *p,*q;
	char *tok;
	if (id()) { 
		add(p_val);
		manline=strrepcat(manline,p_val);
		manline=strrepcat(manline," ");
		if (terminal(":")) { 
			if (!terminal(":")) { error(); return(0); }
			if (!id()) { error(); return(0); }
			add("::"); add(p_val);
			manline=strrepcat(manline,"::");
			manline=strrepcat(manline,p_val);
			}
		manline=strrepcat(manline," ");
		add("()");
		}
	else
	if (terminal("\"")) { 
		if (!match()) { error(); return(0); }
		add("terminal(\""); add(p_matched->lines[0]); add("\")");
		
		manline=strrepcat(manline,"\"");
		
		p=p_matched->lines[0];
		tok=strdup("");
		
		while (q=strchr(p,'\\')) {
			*q=0;
			tok=strrepcat(tok,p);
			tok=strrepcat(tok,"\\(rs");
			*q='\\';
			p=q+1;
			}
		if (*p) tok=strrepcat(tok,p);
		
		manline=strrepcat(manline,tok);
		free(tok);
		manline=strrepcat(manline,"\" ");
		if (!terminal("\"")) { error(); return(0); }
		}
	else return(0);
	return(!p_fatal);
	}

int ppg::list()
{	if (p_fatal) return(0);
	debug("list,");

	if (token()) { 
		printf("if ("); flush(); printf(") { "); printlf(1); 
		do {	if (loop()) { 
				}
			else
			if (option()) { 
				}
			else
			if (token()) { 
				printf("if (!"); flush(); printf(") { error(); return(0); }");
				printlf(0);
				}
			else
			if (cbody()) { 
				}
			else break; } while(!p_fatal);
		printf("}"); printlf(-1); 
		}
	else return(0);
	return(!p_fatal);
	}

int ppg::choice()
{	if (p_fatal) return(0);
	debug("choice,");

	if (list()) { 
		do {	if (terminal("|")) { 
				printf("else"); printlf(0);
				manline=strrepcat(manline,"| ");
				if (!list()) { error(); return(0); }
				}
			else break; } while(!p_fatal);
		}
	else return(0);
	return(!p_fatal);
	}

int ppg::option()
{	if (p_fatal) return(0);
	debug("option,");

	if (terminal("[")) { 
		manline=strrepcat(manline,"[ ");
		if (!choice()) { error(); return(0); }
		if (!terminal("]")) { error(); return(0); }
		manline=strrepcat(manline,"] ");
		}
	else return(0);
	return(!p_fatal);
	}

int ppg::loop()
{	if (p_fatal) return(0);
	debug("loop,");

	if (terminal("(")) { 
		printf("do {\t"); indent++;
		manline=strrepcat(manline,"( ");
		if (cbody()) { 
			}
		if (!choice()) { error(); return(0); }
		if (terminal("!")) { 
			manline=strrepcat(manline,"! ");
			if (!choice()) { error(); return(0); }
			}
		if (!terminal(")")) { error(); return(0); }
		printf("else break; } while(!p_fatal);"); printlf(-1);
		manline=strrepcat(manline,") ");
		}
	else return(0);
	return(!p_fatal);
	}

int ppg::formula()
{	if (p_fatal) return(0);
	debug("formula,");

	if (choice()) { 
		printf("else return(0);");
		printlf(0);
		printf("return(!p_fatal);");
		printlf(0);
		}
	else
	if (option()) { 
		if (cbody()) { 
			}
		printf("return(!p_fatal);");
		printlf(0);
		}
	else
	if (loop()) { 
		if (cbody()) { 
			}
		printf("return(!p_fatal);");
		printlf(0);
		}
	else
	if (cbody()) { 
		if (!formula()) { error(); return(0); }
		}
	else return(0);
	return(!p_fatal);
	}

int ppg::def()
{	if (p_fatal) return(0);
	debug("def,");

	if (id()) { 
		char str[64];
		
		printf("int ");
		if (classname) printf("%s::",classname);
		printf("%s()\n",p_val);
		printf("{\tif (p_fatal) return(0);\n");
		printf("\tdebug(\"%s,\");\n\n\t",p_val,p_val);
		indent++;
		manual->add_line(".PP");
		sprintf(str,"%s : ",p_val);
		manual->add_line(str);
		manual->add_line(".br");
		manual->add_line(".in +0.8i");
		manual->add_line(".ad l");
		manual->add_line(".nh");
		manline=strdup("");
		if (!terminal(":")) { error(); return(0); }
		if (!formula()) { error(); return(0); }
		printf("}"); printlf(-1); printlf(0);
		
		manual->add_line(manline);
		manual->add_line(".br");
		manual->add_line(";");
		manual->add_line(".br");
		manual->add_line(".hy");
		free(manline);
		manline=0;
		}
	else return(0);
	return(!p_fatal);
	}

int ppg::cheader()
{	if (p_fatal) return(0);
	debug("cheader,");

	if (terminal("{")) { 
		if (!match()) { error(); return(0); }
		{	char **p; 
			FILE *fp;
		
			char fname[256];
		
			printf("#ifdef __cplusplus"); printlf(0);
			printf("extern \"C\" {"); printlf(0);
			printf("#endif"); printlf(0);
			printlf(0);
		
			printf("#include <stdio.h>"); printlf(0);
			printf("#include <stdlib.h>"); printlf(0);
			printf("#include <string.h>"); printlf(0);
			printlf(0);
		
			printf("#ifdef __cplusplus"); printlf(0);
			printf("	}"); printlf(0);
			printf("#endif"); printlf(0);
			printlf(0);
		
			printf("#include \"tw_types.h\""); printlf(0);
			printf("#include \"mystring.h\""); printlf(0);
			printf("#include \"%s.h\"",classname);
			printlf(0);
			printlf(0);
		
			sprintf(fname,"%s.h",classname);
			fp = fopen(fname,"w");
			if (!fp) { error(); return(0); }
		
			fprintf(fp,"#ifndef H_%s\n",classname);
			fprintf(fp,"#define H_%s\n\n",classname);
		
			if (parent) 
				fprintf(fp,"#include \"%s.h\"\n\n",parent);
			else	fprintf(fp,"#include \"parser.h\"\n\n");
		
			fprintf(fp,"class %s : public %s {\n",
				classname, parent ? parent : "Parser" );
			fprintf(fp,"\tpublic :\n"); 
		
			p=p_matched->lines;
			while (*p) {
				fprintf(fp,"\t\t%s\n",*(p++)); 
				}
			fprintf(fp,"\t};\n\n");
		
			fprintf(fp,"#endif\n");
			fclose(fp);
		
			manual->add_line(".SH SYNOPSYIS");
			manual->add_line(".nf");
			sprintf(fname,"class %s : public %s {",
				classname, parent ? parent : "Parser" );
			manual->add_line(fname);
			p=p_matched->lines;
			while (*p) {
				sprintf(fname,"	%s",*p);
				manual->add_line(fname);
				p++;
				}
			manual->add_line("	}");
			manual->add_line(".fi");
			}
		if (!terminal("}")) { error(); return(0); }
		}
	else return(0);
	return(!p_fatal);
	}

int ppg::cbody()
{	if (p_fatal) return(0);
	debug("cbody,");

	if (terminal("{")) { 
		if (!match()) { error(); return(0); }
		{
		char **p;
		
		p=p_matched->lines;
		while (*p) {
			printf("%s",*(p++));
			printlf(0);
			}
		}
		if (!terminal("}")) { error(); return(0); }
		}
	else return(0);
	return(!p_fatal);
	}

int ppg::include()
{	if (p_fatal) return(0);
	debug("include,");

	if (terminal("include")) { 
		do {	if (terminal("\"")) { 
				if (!match()) { error(); return(0); }
				if (!terminal("\"")) { error(); return(0); }
				printf("#include \"%s\"\n",p_matched->lines[0]); 
				}
			if (terminal("include")) { 
				}
			else break; } while(!p_fatal);
		printf("\n");
		}
	return(!p_fatal);
	}

int ppg::classes()
{	if (p_fatal) return(0);
	debug("classes,");

	if (terminal("class")) { 
		if (!id()) { error(); return(0); }
		classname = strdup(p_val); 
		if (terminal(":")) { 
			if (!id()) { error(); return(0); }
			parent = strdup(p_val); 
			}
		if (!cheader()) { error(); return(0); }
		}
	else return(0);
	return(!p_fatal);
	}

int ppg::definitions()
{	if (p_fatal) return(0);
	debug("definitions,");

	manual->add_line(".SH IMPLEMENTATION");
	if (def()) { 
		do {	if (terminal(";")) { 
				if (!def()) { error(); return(0); }
				}
			else break; } while(!p_fatal);
		if (!terminal(".")) { error(); return(0); }
		}
	else return(0);
	return(!p_fatal);
	}

int ppg::grammar()
{	if (p_fatal) return(0);
	debug("grammar,");

	if (include()) { 
		if (!classes()) { error(); return(0); }
		if (!include()) { error(); return(0); }
		if (!definitions()) { error(); return(0); }
		p_matched_noindent =0; 
		if (cbody()) { 
			}
		}
	else return(0);
	return(!p_fatal);
	}

/* --------------------------------------------------------------------------
   * And this is the implentation of the non parsing functions of the object
   */


ppg::ppg(LineStream *InitStream) : Parser(InitStream)
{	stack = new Text(1);
	classname =0;
	indent=0;
	parent=0;
	manual= new Text(16);
	man_flag=0;
	manline=0;
	}

ppg::~ppg()
{	delete stack;
	if (classname) free(classname);
	if (manline) free(manline);
	}

void ppg::add(char *str)
{	if (str) {
		debug("stack("); debug(str); debug(") ");
		stack->add_line(str);
		}
	}

void ppg::flush()
{	char **p;

	p = stack->lines;
	while (p && *p) {
		printf("%s",*p); p++;
		}
	stack->purge();
	}

void ppg::printlf(int offs)
{	int i;

	indent+=offs;
	printf("\n");
	for (i=0;i<indent;i++) printf("\t");
	}

int ppg::line_comment()
{	char *p;
	if (p_pos == p_line+1) {
		p=p_pos;
		while (*p && strchr(" \t",*p)) p++;
		manual->add_line(p);
		}

	return(Parser::line_comment());
	}
 
main(int argc,char **argv)
{	FileStream *prgm;
	ppg *parser;
	char *infilename;
	char fname[64];
	FILE *fp;
	char **p;

	infilename = 0;

	while (--argc) {
		argv++;
		if (!memcmp(*argv,"-d",2)) parser_debug=1;
		else infilename = *argv;
		}

	if (infilename) 
		prgm = new FileStream(infilename,O_RDONLY);
	else	prgm = new FileStream(0,O_RDONLY);

	if (prgm->fd>=0) {
		parser = new ppg(prgm);		
		parser->grammar();

		if (parser->p_error->nlines) {
			char **p;

			p=parser->p_error->lines;
			while (*p) {
				fprintf(stderr,"%s\n",*p);
				p++;
				}
			}

		p=parser->manual->lines;
		if (*p) {
			sprintf(fname,"%s.man",parser->classname);
			fp = fopen(fname,"w");
			if (fp) {
				while (*p) {
					fprintf(fp,"%s\n",*p);
					p++;
					}
				fclose(fp);
				}
			}

		delete parser;
		delete prgm;
		}
	else	fprintf(stderr,"No stdin ?");
	}
