#include "string.h"
#include "stdio.h"
#include "unistd.h"
#include "stdlib.h"
#include "tw_types.h"
#include "SqlInformix.h"
#include "onyx_config.h"

#ifdef SUNOS
extern "C" {
	extern int putenv();
	extern int fprintf();
	}
#endif

SqlInformix::SqlInformix()
	: SqlPipe()
{	
	}

SqlInformix::~SqlInformix()
{	}

int SqlInformix::sql_open()
{	char *p;
	char cmd[256];
	char path[1024];

#ifdef INFORMIX_HOME
	if (sql_in) {
		error("Database already open");
		return(0);
		}

	if ((p=strchr(sql_database,'%'))) { 	/* extract engine name */
		*p=0;
		sprintf(cmd,"isql %s",sql_database);
		*p='%';
		if (strcmp(p+1,"informix") && strcmp(p+1,"isql")) {
			message("Wrong engine %s\n",p+1);
			return(0);
			}
		}
	else	sprintf(cmd,"isql %s",sql_database);
		
/*
	sprintf(path,"INFORMIXDIR=%s",INFORMIX_HOME);
	putenv(path);
	message(path);
	sprintf(path,"PATH=%s/bin:%s",INFORMIX_HOME,getenv("PATH"));
	message(path);
*/
	putenv("DBDELIMITER=\t");
	message(cmd);

	switch (sql_pipe(&sql_in,&sql_out,&sql_err)) {

		case -1:				/* error */

			message("Fork to %s failed",cmd);
			return(0);
			break;

		case 0:					/* child */
			chdir(GSQL_DATA);
			/* exec the shell to run the command */
			execl("/bin/sh", "/bin/sh", "-c", cmd, (char *)0);

			/* if we get here, exec failed */
			fprintf(stderr,"exec to %s failed\n",cmd);
			exit(1);
		}
	sql_timeout = 100;

#endif

	return(1);
	}
