#include "string.h"
#include "stdio.h"
#include "unistd.h"
#include "stdlib.h"
#include "tw_types.h"
#include "SqlShql.h"
#include "onyx_config.h"

SqlShql::SqlShql()
	: SqlPipe()
{	
	}

SqlShql::~SqlShql()
{	}

int SqlShql::sql_open()
{	char *p;
	char cmd[256];

	if (sql_in) {
		error("Database already open");
		return(0);
		}

	if ((p=strchr(sql_database,'%'))) { 	/* extract engine name */
		*p=0;
		sprintf(cmd,"%s %s",SHQL_BIN_PATH,sql_database);
		*p='%';
		if (strcmp(p+1,"shql")) {
			error("Wrong engine %s\n",p+1);
			return(0);
			}
		}
	else	sprintf(cmd,"%s %s",SHQL_BIN_PATH,sql_database);
		
	switch (sql_pipe(&sql_in,&sql_out,&sql_err)) {

		case -1:				/* error */

			message("Fork to %s failed",cmd);
			return(0);
			break;

		case 0:					/* child */

			/* exec the shell to run the command */
			chdir(GSQL_DATA);
			execl("/bin/sh", "/bin/sh", "-c", cmd, (char *)0);

			/* if we get here, exec failed */
			exit(1);
		}

	sql_timeout = 100;

	/*
	fprintf(stderr,"sql_in = %d\n",sql_in);
	*/

	return(1);
	}
